So wie wir heute Uber den CAN mit den CanConfigCodec aus ADTF2 kommunizieren kdnnen, missen wir mit den zukinftigen
Steuergeraten auch tber SOME/IP via Ethernet kommunizieren kénnen.

Was beim CAN die DBC-Datei ist, wére bei SOME/IP eine Autosar-XML-Datei (ARXML). Basierend auf den Signal-Beschreibungen
im ARXML benétigen wir eine Bibliothek um SOME/IP Botschaften aus C++-Structs zu generieren und umgekehrt.

Ist eine Unterstiitzung/Toolbox fir SOME-IP geplant oder in Entwicklung?
Wenn ja, wann wird das kommen?

Wenn nein, warum nicht?

Lésung

Die Unterstiitzung fur SOME/IP wird gerade umgesetzt - die ersten Features erscheinen mit der ADTF Device Toolbox 3.1.

Damit ist es moglich, SOME/IP-Nachrichten von einem Netzwerkadapter oder einer Pcap-Datei abzugreifen.
ADTF verhélt sich dabei passiv d.h. vorhandener Traffic wird wird mittels Pcap mitgelesen - &hnlich zu Tools wie Wireshark.

Zur Darstellung der Nachrichten liefern wir das SOME/IP Trace View (siehe angefiigter Screenshot).

Neben den einzelnen Header-Feldern werden auch Service-Discovery-Informationen angezeigt.
Die eigentliche Payload einer Nachricht wird aktuell im Rohformat (hexadezimal) angezeigt.

In der ersten lteration wird ADTF keine Funktionalitdt zum Dekodieren der Payload enthalten,
die nétige Anbindung von ARXML- / Fibex-Parsern steht noch aus.

Grundsétzlich planen wir die kiinftige Anbindung solcher Parser Uber ein standardisiertes Interface Seitens der Device Toolbox.
So geben wir Anwendern die Modglichkeit, bei Bedarf eigene ARXML- / Fibex-Parser anzubinden.

Ob und in welchem Rahmen die Device Toolbox bereits Parser out-of-the-box zur Verfligung stellen wird, kann ich aktuell nicht
beantworten.

Wie die (De)serialisierung von C++-Structs genau aussehen wird ist ebenfalls noch offen.
Mangels Reflection in C++ sehe ich 2 Herangehensweisen:

e automatische Code-Generierung (mittels Tool)
e manuelle (De)serialisierung (mittels unterstiitzender Library)
B ADTF - default_session

someip_trace_view.ui_service.devicetb g X
Count TimeStamp (ns) Source IP Destination IP Protocol Message Type VLAN ID 2
8 1549915139007548000  192.168.1.122 192.168.1.217 UDP Request 1
9 1549915139008276000  192.168.1.217 192.168.1.122 Upp Response 1
10 1549915139099009000  192.168.1.122 192.168.1.217 UDP Request 1
i 1349915139099013000  192.168.1.217 192.168.1.122 Upp Error 1
12 1549915139099741000  192.168.1.122 192.168.1.217 UDP Request 1
12 1349915139100464000  192.168.1.217 192.168.1.122 Upp Response 1
14 1549915139101191000  192.168.1.122 192.168.1.217 upp Request 1
15 1549915139101935000  192.168.1.217 192.168.1.122 UDP Response 1
16 1549915139102843000  192.168.1.122 192.168.1.217 upp Request 1
17 1549915139103678000  192.168.1.217 192.168.1.122 UDP Response 1
18 1549915139104455000  192.168.1.122 192.168.1.217 upp Request 1
19 1549915139105280000  192.168.1.217 192.168.1.122 UDP Response 1
20 1549915139105287000  192.168.1.217 192.168.1.122 upp Error 1
21 1549915139106097000  192.168.1.217 192.168.1.122 upp Response 1
22 1349915139106928000  192.168.1.122 192.168.1.217 upp Request 1
23 1549915139107676000  192.168.1.217 192.168.1.122 Upp Response 1
24 1549915139108474000  192.168.1.122 192.168.1.217 UDP Request 1
25 1349915139109284000  192.168.1.217 192.168.1.122 Upp Response 1
26 1549915139110075000  192.168.1.122 192.168.1.217 UDP Request 1
27 1349915139110762000  192.168.1.217 192.168.1.122 Upp Response 1
28 1549915139111574000  192.168.1.122 192.168.1.217 UDP Request 1
29 1349915139111591000  192.168.1.217 192.168.1.122 Upp Error 1
30 1549915139112340000  192.168.1.122 192.168.1.217 upp Request 1
3 1549915139113142000  192.168.1.217 192.168.1.122 UDP Response 1
32 1549915139113851000  192.168.1.122 192.168.1.217 Upp Request 1
33 1549915139114637000  192.168.1.217 192.168.1.122 UDP Response 1
34 1549915139115469000  192.168.1.122 192.168.1.217 upp Request 1
35 1549915139120221000  192.168.1.122 192,168.1.143 UDP Response (TP fragment) 1
36 1549915139120226000  192.168.1.122 192.168.1.143 Upp Response (TP fragment) 1
37 1549915139120228000  192.168.1.122 192.168.1.143 UDP Response (TP fragment) 1
38 1349915139120230000  192.168.1.122 192.168.1.143 upp Response (TP fragment) 1 w
Field Name Data
v Message

Message Type RESPONSE

Length 116

Message ID 594944954

Request ID 386328522

Interface Version @

Return Code []4

Last Fragment False

v Payload TP Fragment
ax88 x8d 8x88 @xel exbB ex3C 8xdD axe7
@xDE @x5D 8x8F @xb65 e@xCl exDs8 8x@l 8x96
@xC2 BxEF 8xBA 9x48 8xCE Ox4A 9x99 8xEBF
Bx69 Bx24 BxF8 @x54 8x38 8x53 8xBB @xDE
@x25 8x11 8xEBE @x8A 8x5D exDE 8x59 8x6B
@x37 8x69 8x8A @xEl @xDF @x56 8x98 8xe6
Raw Data @xB3 8xC2 8x99 @x@l 8xBC ex1f6 @xd4l exAD

@xCD 8x16 8x37 @x75 @xFB 8xBF B8xA8 @xC2
@xB3 8x29 B8x11 8xb64 8xBA 8x68 Bx5B 8xFC
BxEC 8x68 BxE7 @x4B8 @xB3 @x97 8xAD 8x9E
@x8A Bx36 Bx1E Ox28 OuFF 0x3D oxC9 8x71
@xB5 8xBE B8xAB @x3A 8x71 8xD4 8x25 8x48

BxBA 8xD9 ex7A

BxdE
B ADTF - default_session

v [@] Configuration
Service Name
Revision

Infotainment Registry
16.84

someip_trace_view.ui_service.devicetb g X
Count TimeStamp (ns) Source IP Destination IP Protocol Message Type VLAN ID 2
1 1549915139002505000  192.168.1.122 192,168.1.217 UDP Service Discovery 1
2 1549915139092543000  192.168.1.122 192.168.1.217 upDp Service Discovery 1
3 1549915139093392000  192.168.1.217 192.168.1.122 UDP Response 1
4 1549915139094228000  192.168.1.122 192.168.1.217 UDP Request 1
5 1549915139095050000  192.168.1.217 192.168.1.122 UDP Response 1
6 1549915139095879000  192.168.1.122 192.168.1.217 UDP Request 1
7 1549915139096713000  192.168.1.217 192.168.1.122 UDP Response 1
8 1549915139007548000  192.168.1.122 192.168.1.217 UDP Request 1
9 1549915139098276000  192.168.1.217 192.168.1.122 uDp Response 1
10 1549915139009009000  192.168.1.122 192.168.1.217 UDP Request 1
11 1549915139099013000  192.168.1.217 192.168.1.122 uDp Error 1
12 1549915139099741000  192.168.1.122 192.168.1.217 UDP Request 1
13 1549915139100464000  192.168.1.217 192.168.1.122 UDp Response 1
14 1549915139101191000  192.168.1.122 192.168.1.217 UDpP Request 1
15 1549915139101935000  192.168.1.217 192.168.1.122 UDp Response 1
16 1549915139102843000  192.168.1.122 192.168.1.217 UDpP Request 1
17 1549915139103678000  192.168.1.217 192.168.1.122 UDP Response 1
18 1549915139104455000  192.168.1.122 192.168.1.217 upDp Request 1
19 1549915139105280000  192.168.1.217 192.168.1.122 UDP Response 1
20 1549915139105287000  192.168.1.217 192.168.1.122 upDp Error 1
21 1549915139106091000  192.168.1.217 192.168.1.122 UDP Response 1
22 1549915139106928000  192.168.1.122 192.168.1.217 UDP Request 1
23 1549915139107676000  192.168.1.217 192.168.1.122 UDP Response 1
24 1549915139108474000  192.168.1.122 192.168.1.217 UDP Request 1
25 1549915139109284000  192.168.1.217 192.168.1.122 UDp Response 1
26 1549915139110075000  192.168.1.122 192.168.1.217 UDP Request 1
27 1549915139110762000  192.168.1.217 192.168.1.122 uDp Response 1
28 1549915139111574000  192.168.1.122 192.168.1.217 UDP Request 1
29 1549915139111591000  192.168.1.217 192.168.1.122 uDp Error 1
30 1549915139112340000  192.168.1.122 192.168.1.217 UDP Request 1
3 1549915139113142000  192.168.1.217 192.168.1.122 UDP Response 1 v
Field Name Data
v Message

Message Type NOTIFICATION
Length 153
Message ID 4294934784
Request ID 1
Interface Version 1
Return Code OK
v Service Discovery
Flags None
v Entries 1
w [B] Service Entry
First Option Index 2]
Second Optien Index @
First Option Count 1
Second Option Count 1
Service ID 12
Instance ID 4
TTL 18
Major Version 1
Minor Version a
v Options 1

Compatibility Context SameOrhewer
v [1] IPv4 Endpoint

Protocol upp

IP Address 192.168.8.238

Port 1617
~ [2] Load Balancing

Priority 1

Weight 28

Zusammengefasst:

¢ Bis Ende Q2/19: Tracing + Aufzeichnen von SOME/IP-Traffic
e Spater: (De)serialisierung und Interpretation der Payload, Anbindung von Config-Parsern

History

#1 - 2019-02-26 12:34 - hidden

- Status changed from New to In Progress
- Topic set to DeviceTB::SOME/IP
- Affected Products ADTF Device Toolbox 3.0.0, ADTF Device Toolbox 3.1.0 added
- Platform Windows 7 64bit added

@Wolfgang: Bitte dem Anwender Infos zur Some IP Unterstitzung geben.

#2 - 2019-02-26 16:41 - hidden

Hallo Herr Rennekamp,

Die Unterstiitzung fir SOME/IP wird gerade umgesetzt - die ersten Features erscheinen mit der ADTF Device Toolbox 3.1.

Damit ist es mdglich, SOME/IP-Nachrichten von einem Netzwerkadapter oder einer Pcap-Datei abzugreifen.
ADTF verhélt sich dabei passiv d.h. vorhandener Traffic wird wird mittels Pcap mitgelesen - &hnlich zu Tools wie Wireshark.

Zur Darstellung der Nachrichten liefern wir das SOME/IP Trace View (siehe angefiigter Screenshot).

Neben den einzelnen Header-Feldern werden auch Service-Discovery-Informationen angezeigt.
Die eigentliche Payload einer Nachricht wird aktuell im Rohformat (hexadezimal) angezeigt.

In der ersten lteration wird ADTF keine Funktionalitdt zum Dekodieren der Payload enthalten,
die nétige Anbindung von ARXML- / Fibex-Parsern steht noch aus.

Grundsatzlich planen wir die kiinftige Anbindung solcher Parser Uiber ein standardisiertes Interface Seitens der Device Toolbox.

So geben wir Anwendern die Méglichkeit, bei Bedarf eigene ARXML-/ Fibex-Parser anzubinden.

Ob und in welchem Rahmen die Device Toolbox bereits Parser out-of-the-box zur Verfligung stellen wird, kann ich aktuell nicht beantworten.

Wie die (De)serialisierung von C++-Structs genau aussehen wird ist ebenfalls noch offen.
Mangels Reflection in C++ sehe ich 2 Herangehensweisen:

- automatische Code-Generierung (mittels Tool)
- manuelle (De)serialisierung (mittels unterstiitzender Library)

Zusammengefasst:

- Bis Ende Q2/19: Tracing + Aufzeichnen von SOME/IP-Traffic
- Spéter: (De)serialisierung und Interpretation der Payload, Anbindung von Config-Parsern

#3 - 2019-02-26 16:42 - hidden
- File someip_trace_raw.png added

- File someip_trace _sd.png added

#4 - 2019-02-26 16:44 - hidden

- Status changed from In Progress to Customer Feedback Required

#5 - 2019-03-07 14:10 - hidden

- Project changed from 20 to Public Support

- Subject changed from SOME-IP Kommunikation to Support for SOME/IP in ADTF 3.x
- Description updated

- Status changed from Customer Feedback Required to To Be Closed

- Private changed from Yes to No

- Resolution set to Solved Issue

#6 - 2019-03-08 13:27 - hidden
- Status changed from To Be Closed to Closed
